;DATE: 2013-01-15
;REF: program inspired by http://picatout-jd.blogspot.fr/2013/01/carte-de-voeux-musicale.html
;REF: gamme tempre: http://davbucci.chez-alice.fr/index.php?argument=musica/scala/scala.inc
;REF: happy birthday: http://en.wikipedia.org/wiki/File:GoodMorningToAll.svg

#include P10F202.INC

    __config  _WDTE_OFF & _MCLRE_OFF

;;;;;;;;;;;; constantes ;;;;;;;;;;

;dures notes
WHOLE_NOTE EQU 0
HALF_NOTE EQU 1
QUARTER_NOTE EQU 2
HEIGHT_NOTE EQU 3
SIXTEENTH EQU 4
PAUSE_BIT EQU 7



;;;;;;;;;;;; macros ;;;;;;;;;;;;;;
#define AUDIO_P GP0
#define AUDIO GPIO, AUDIO_P
;#define NBRE_ITERATION .245 ; pour le dcompte du timer0
;#define SW GP3
set_SW macro  ; met GP3 en entre
	 movlw   b'1110'         ; configure GP1 (only) as an output
     tris    GPIO
     endm

audio_hi macro ; met la  broche audio au niveau 1
    bsf AUDIO
    endm

audio_lo macro ; met la broche audio au niveau 0
    bcf AUDIO
    endm

enable_audio macro  ; met la broche audio en mode sortie
    movlw H'FF' - (1<<AUDIO_P)
    tris GPIO
    endm

disable_audio macro  ; met la broche audio en haute impdance (mode entre)
    movlw H'FF'
    tris GPIO
    endm

delay_half_cycle macro ; dlais demi-cycle pour gnrer une note
    comf freq_dly, W
    addwf TMR0
    movfw TMR0
    skpz
    goto $-2
    endm

skip_timeout macro  ; dlais dure de la note
    movfw freq_dly
    subwf delay_cntr, F
    skpnc
    goto $+7
    movlw 1
    subwf delay_cntr+1, F
    skpnc
    goto $+3
    subwf delay_cntr+2, F
    skpnc
    endm



	
;;;;;;;;;;;; variables ;;;;;;;;;;;;
    udata
delay_cntr res 3 ; compteur pour dlais dure notes
freq_dly res 1 ; dlais demi-cycle pour produire la frquence x
note_idx res 1 ; index de la note dans la table melody
temp res 2 ; registres de travail temporaire

rst_vector org 0
    clrf OSCCAL
    nop
    goto init

;minuterie
;initialisation du compteur
;	movlw ~NBRE_ITERATION
;	movwf compteur
;initalisation du TIMER0
;init_tmr0
;	movlw 1
;	movwf TMR0
;	movlw B'10000110' ; pr-division par 128 
;	option ; W -> OPTION
;boucle
;	movfw TMR0 ; TMR0 -> W
;	skpz ; si W==0 on saute le "goto boucle"
;	goto boucle
;	incfsz compteur,F ; incrmente le compteur de dlais
;	goto init_tmr0 ; cette instruction est saut si compteur==0
;	return ; on retourne  la procdure appelante.

scale
; table des notes chelle tempre
    addwf PCL, F
    dt .239  ;do4
    dt .225  ;do#4
    dt .212  ;r4
    dt .201  ;r#4
    dt .189  ;mi4
    dt .179  ;fa4
    dt .169  ;fa#4
    dt .159  ;sol4
    dt .150  ;sol#4
    dt .142  ;la4
    dt .134  ;la#4
    dt .126  ;si4
    dt .119  ;do5
    dt .112  ;do#5
    dt .106  ;r5
    dt H'FE' ; pause

duration
; table des dures en multiple de 8 microsecondes
    addwf PCL, F
    dt low .62500, high .62500, 0    ; WHOLE_NOTE 
    dt low .93750, high .93750, upper .93750; WHOLE_NOTE.
    dt low .31250, high .31250, 0    ; HALF_NOTE
    dt low .46875, high .46875, 0  ; HALF_NOTE.
    dt low .15625, high .15625,0   ; QUARTER_NOTE
    dt low .23437, high .23437, 0 ; QUARTER_NOTE.
    dt low .7812, high .7812,0    ; HIEGTH_NOTE
    dt low .11718, high .11718, 0 ; HEIGTH_NOTE.
    dt low .3906, high .3906, 0 ; SIXTHEENTH_NOTE.
    dt low .5859, high .5859, 0 ; SXTHEENTH_NOTE.



melodie
; table des mlodies 'Mon Beau Sapin' 'Happy Birthday to you'
; bits 0-3 index de la note dans la table 'scale', 15=pause
; bits 4-6 index de la dure de la note dans la table 'duration'
 

	addwf PCL, F
 ;---------- mlodie de Nol "Mon Beau Sapin Christmas Tree" ---------
 	dt .15  ;pause
	dt .32 ; mon
	dt .37 ; beau
	dt .69 ; sa
	dt .37 ; pin
	dt .39 ; roi
	dt .41 ; des
	dt .73 ; fo
	dt .57 ; rets
	dt .73 ; que
	dt .71 ; j'ai
	dt .73 ; me
	dt .74 ; ta
	dt .84 ; ver
	dt .39 ; du
	dt .37 ; re
	dt .76 ; quand
	dt .76 ; par
	dt .73 ; l'hi
	dt .62 ; vert
	dt .76 ; bois
	dt .76 ; et
	dt .74 ; gu
	dt .58 ; rets
	dt .74 ; sont 
	dt .74 ; d
	dt .71 ; pouil 
	dt .60 ; ls
	dt .74 ; de
	dt .74 ; leurs
	dt .121 ; at 
	dt .89 ; traits
	dt .32 ; mon
	dt .37 ; beau
	dt .69 ; sa
	dt .37 ; pin
	dt .39 ; roi
	dt .41 ; des
	dt .73 ; fo
	dt .57 ; rets
	dt .73 ; tu
	dt .71 ; gar
	dt .73 ; des
	dt .74 ; ta
	dt .84; par
	dt .39 ; ru
	dt .37 ; re
    dt .15 ;pause   
;dt H'FF' ; fin


; ---------- mlodie "Vive le Vent" ----------
    ;addwf PCL, F
    dt .15   ;pause
	dt .73	;	la		Viv'
    dt .73	;	la		le
    dt .41	;	la		vent
    dt .73	;	la		viv'
    dt .73	;	la		le
    dt .41	;	la		vent
    dt .73	;	la		viv'
    dt .76	;	do5		le
    dt .69	;	fa		vent
    dt .71	;	sol		d'hi
    dt .41	;	la		ver
    dt .75	;	si		qui
    dt .75	;	si		s'en
    dt .91	;	si		va
    dt .108 ;   do5		sif
    dt .75  ; 	si		flant
    dt .73  ;   la		souf
    dt .89  ;	la		flant
    dt .73	;	la		dans
    dt .73	;	la		les 
    dt .71	;	sol		grands
    dt .71	;	sol		sa
    dt .73	;	la		pins
    dt .39	;	sol		verts
    dt .15 ;    pause   
;++++++++++++++++++++++++++++ Pic 10F202  uniquement (son  retravailler)  ++++++++++++++++++++++++++++++
   
   ;dt .64	;	do		sur
   ;dt .73	;	la		le
   ;dt .71	;	sol		long
   ;dt .69	;	fa		che
   ;dt .48	;	do		min
   ;dt .64	;	do		tout
   ;dt .64	;	do		blanc
   ;dt .73	;	la		de
   ;dt .71	;	sol		nei
   ;dt .69	;	fa		ge
   ;dt .50	;	r		blanche
   ;dt .66	;	r		un
   ;dt .66	;	r		vieux
   ;dt .75	;	si		Mon
   ;dt .73	;	la		sieur
   ;dt .71	;	sol		S'a 
   ;dt .76	;	do5		vance
   ;dt .76	;	do5		a 
   ;dt .76	;	do5		vec
   ;dt .76	;	do5		sa
   ;dt .78	;	r5		can
   ;dt .76	;	do5		ne
   ;dt .75	;	si		dans
   ;dt .71	;	sol		la
   ;dt .25	;	la		main
   ;dt .15   ;  pause  

   ; dt .64	;	do		et
   ; dt .64	;	do		tout
   ; dt .73	;	la		l
   ; dt .71	;	sol		haut
   ; dt .69	;	fa		le
   ; dt .48	;	do		vent
   ; dt .64	;	do		qui
   ; dt .64	;	do		sif
   ; dt .73	;	la		fle
   ; dt .71	;	sol		dans
   ; dt .69	;	fa		les 
   ; dt .50	;	r		branches
   ; dt .66	;	r		lui
   ; dt .66	;	r		souf
   ; dt .75	;	si		fle
   ; dt .73	;	la		la
   ; dt .71	;	sol		ro
   ; dt .76	;	do5		man
   ; dt .76	;	do5		ce
   ; dt .76	;	do5		qu'il
   ; dt .76	;	do5		chan
   ; dt .78	;	r5		tait
   ; dt .76	;	do5		pe
   ; dt .75	;	si		tit
   ; dt .71	;	sol		en
   ; dt .25	;	la		fant
   ; dt .15  ;pause
   
    ;dt .15   ;pause
	;dt .73	;	la		Viv'
    ;dt .73	;	la		le
    ;dt .41	;	la		vent
    ;dt .73	;	la		viv'
    ;dt .76	;	la		le
    ;dt .69	;	la		vent
    ;dt .73	;	la		viv'
    ;dt .76	;	do5		le
    ;dt .69	;	fa		vent
    ;dt .71	;	sol		d'hi
    ;dt .41	;	la		ver
    ;dt .75	;	si		qui
    ;dt .75	;	si		s'en
    ;dt .91	;	si		va
    ;dt .108 ;	do5		sif
    ;dt .75	;	si		flant
    ;dt .105	;	la		souf
    ;dt .89	;	la		flant
    ;dt .73	;	la		dans
    ;dt .73	;	la		les 
    ;dt .71	;	sol		grands
    ;dt .71	;	sol		sa
    ;dt .73	;	la		pins
    ;dt .71	;	sol		verts
	;dt .15 ;    pause   
   
   ; dt .44	;	do5		Oh!
   ; dt .73	;	la		Viv'
   ; dt .73	;	la		le
   ; dt .41	;	la		vent
   ; dt .73	;	la		viv'
   ; dt .73	;	la		le
   ; dt .41	;	la		vent
   ; dt .73	;	la		viv'
   ; dt .76	;	do5		le
   ; dt .69	;	fa		vent
   ; dt .71	;	sol		d'hi
   ; dt .41	;	la		ver
   ; dt .75	;	si		boule
   ; dt .75	;	si		de
   ; dt .91	;	si		neige
   ; dt .108 ;	do5		et
   ; dt .75	;	si		jour
   ; dt .73 ;	la		de
   ; dt .73	;	la		l'an
   ; dt .105 ;	la		et
   ; dt .73	;	la		bonne
   ; dt .71	;	sol		an
   ; dt .71	;	sol		ne
   ; dt .73	;	la		grands
   ; dt .39	;	sol		mre
 
	clrf note_idx
	;dt H'FF' ; fin
	
 	
play_note
; joue une note
; note dans W
; bits 0-3 index de la note dans la table 'scale', 15=pause
; bits 4-6 index de la dure de la note dans la table 'duration'
    movwf temp
    movwf temp+1
    swapf temp, F ; dure dans le low nibble
    movlw H'F'
    andwf temp, F ; ne garde que le low nibble
    bcf STATUS, C ; multiplication par 3
    rlf temp, W
    addwf temp, F
    movfw temp
    call duration
    movwf delay_cntr  ; octet faible
    incf temp,F
    movfw temp
    call duration
    movwf delay_cntr+1 ;octet intermdiaire
    incf temp, W
    call duration
    movwf delay_cntr+2  ; octet fort
    enable_audio
    movlw H'F'
    andwf temp+1, F
    xorwf temp+1, W
    skpz
    goto play_note01
    disable_audio  ; c'est une pause
play_note01
    movfw temp+1
    call scale
    movwf freq_dly  ; dlais en multiple de 4usec.
play_note02
    audio_hi
    delay_half_cycle
    audio_lo
    delay_half_cycle
    skip_timeout
    goto play_note02
    retlw 0

init
    ; timer clk=Fosc/4, diviseur=4
    movlw H'FF' -(1<<T0CS) -(1<<PSA) -(1<<PS1) -(1<<PS2)
    option
   	clrf note_idx
    
    
   

main
music 
    movfw note_idx
    call melodie
    xorlw H'FF' ; marque la fin de la mlodie
    ;skpnz
    ;goto main02
    xorlw H'FF'
    call play_note
    incf note_idx, F
    movlw .4*.16+.15
    call play_note ; brve pause entre les notes
    goto main

;main02
;    sleep   ; termin met le MCU en mode sleep pour mnager la pile.
;    goto $

	
    end
